/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Contents of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.111 - (hide annotations) (download)
Tue Dec 13 21:27:38 2011 UTC (2 years, 6 months ago) by vapier
Branch: MAIN
Changes since 1.110: +6 -1 lines
avoid multiple inclusions when possible to speed caching up

1 vapier 1.105 # Copyright 1999-2011 Gentoo Foundation
2 vapier 1.6 # Distributed under the terms of the GNU General Public License v2
3 vapier 1.111 # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.110 2011/11/14 17:08:49 vapier Exp $
4 vapier 1.76
5     # @ECLASS: autotools.eclass
6     # @MAINTAINER:
7     # base-system@gentoo.org
8     # @BLURB: Regenerates auto* build scripts
9     # @DESCRIPTION:
10     # This eclass is for safely handling autotooled software packages that need to
11     # regenerate their build scripts. All functions will abort in case of errors.
12 azarah 1.1
13 vapier 1.111 if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
14     ___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
15    
16 flameeyes 1.37 inherit eutils libtool
17 azarah 1.11
18 vapier 1.76 # @ECLASS-VARIABLE: WANT_AUTOCONF
19     # @DESCRIPTION:
20     # The major version of autoconf your package needs
21 vapier 1.94 : ${WANT_AUTOCONF:=latest}
22 vapier 1.76
23     # @ECLASS-VARIABLE: WANT_AUTOMAKE
24     # @DESCRIPTION:
25     # The major version of automake your package needs
26 vapier 1.94 : ${WANT_AUTOMAKE:=latest}
27 flameeyes 1.63
28 vapier 1.105 # @ECLASS-VARIABLE: WANT_LIBTOOL
29     # @DESCRIPTION:
30     # Do you want libtool? Valid values here are "latest" and "none".
31     : ${WANT_LIBTOOL:=latest}
32    
33 robbat2 1.95 # @ECLASS-VARIABLE: _LATEST_AUTOMAKE
34 vapier 1.100 # @INTERNAL
35 robbat2 1.95 # @DESCRIPTION:
36     # CONSTANT!
37 flameeyes 1.96 # The latest major version/slot of automake available on each arch.
38 robbat2 1.95 # If a newer version is stable on any arch, and is NOT reflected in this list,
39     # then circular dependencies may arise during emerge @system bootstraps.
40     # Do NOT change this variable in your ebuilds!
41 vapier 1.99 _LATEST_AUTOMAKE='1.11'
42 robbat2 1.95
43 vapier 1.40 _automake_atom="sys-devel/automake"
44     _autoconf_atom="sys-devel/autoconf"
45 peper 1.55 if [[ -n ${WANT_AUTOMAKE} ]]; then
46 flameeyes 1.49 case ${WANT_AUTOMAKE} in
47 vapier 1.67 none) _automake_atom="" ;; # some packages don't require automake at all
48 vapier 1.99 # if you change the "latest" version here, change also autotools_run_tool
49 robbat2 1.95 # this MUST reflect the latest stable major version for each arch!
50 vapier 1.99 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;;
51 vapier 1.67 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
52 flameeyes 1.49 esac
53 vapier 1.64 export WANT_AUTOMAKE
54 flameeyes 1.48 fi
55    
56 vapier 1.45 if [[ -n ${WANT_AUTOCONF} ]] ; then
57 flameeyes 1.41 case ${WANT_AUTOCONF} in
58 vapier 1.67 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
59     2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
60 flameeyes 1.86 # if you change the “latest” version here, change also autotools_run_tool
61 vapier 1.67 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
62 vapier 1.106 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
63 flameeyes 1.41 esac
64 vapier 1.64 export WANT_AUTOCONF
65 flameeyes 1.41 fi
66 vapier 1.93
67 vapier 1.105 _libtool_atom="sys-devel/libtool"
68     if [[ -n ${WANT_LIBTOOL} ]] ; then
69     case ${WANT_LIBTOOL} in
70     none) _libtool_atom="" ;;
71     latest) ;;
72 vapier 1.106 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
73 vapier 1.105 esac
74     export WANT_LIBTOOL
75     fi
76    
77     AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
78 flameeyes 1.46 RDEPEND=""
79 vapier 1.93
80     # @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
81     # @DESCRIPTION:
82     # Set to 'no' to disable automatically adding to DEPEND. This lets
83     # ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
84     # their own DEPEND string.
85 vapier 1.94 : ${AUTOTOOLS_AUTO_DEPEND:=yes}
86 vapier 1.93 if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
87     DEPEND=${AUTOTOOLS_DEPEND}
88     fi
89    
90 vapier 1.40 unset _automake_atom _autoconf_atom
91 azarah 1.11
92 vapier 1.76 # @ECLASS-VARIABLE: AM_OPTS
93 vapier 1.100 # @DEFAULT_UNSET
94 vapier 1.76 # @DESCRIPTION:
95     # Additional options to pass to automake during
96     # eautoreconf call.
97    
98     # @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
99 vapier 1.100 # @DEFAULT_UNSET
100 vapier 1.76 # @DESCRIPTION:
101     # Don't run elibtoolize command if set to 'yes',
102     # useful when elibtoolize needs to be ran with
103     # particular options
104 azarah 1.16
105 cardoe 1.66 # XXX: M4DIR should be deprecated
106 vapier 1.76 # @ECLASS-VARIABLE: AT_M4DIR
107     # @DESCRIPTION:
108     # Additional director(y|ies) aclocal should search
109 vapier 1.94 : ${AT_M4DIR:=${M4DIR}}
110 azarah 1.11
111 vapier 1.76 # @FUNCTION: eautoreconf
112     # @DESCRIPTION:
113 azarah 1.17 # This function mimes the behavior of autoreconf, but uses the different
114     # eauto* functions to run the tools. It doesn't accept parameters, but
115     # the directory with include files can be specified with AT_M4DIR variable.
116 jmbsvicetto 1.81 #
117 vapier 1.76 # Should do a full autoreconf - normally what most people will be interested in.
118     # Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
119 azarah 1.17 eautoreconf() {
120 vapier 1.91 local x auxdir g
121 jmbsvicetto 1.81
122 flameeyes 1.39 if [[ -z ${AT_NO_RECURSIVE} ]]; then
123     # Take care of subdirs
124     for x in $(autotools_get_subdirs); do
125     if [[ -d ${x} ]] ; then
126 vapier 1.91 pushd "${x}" >/dev/null
127 flameeyes 1.39 AT_NOELIBTOOLIZE="yes" eautoreconf
128 vapier 1.91 popd >/dev/null
129 flameeyes 1.39 fi
130     done
131     fi
132 azarah 1.11
133 flameeyes 1.38 auxdir=$(autotools_get_auxdir)
134    
135 vapier 1.91 einfo "Running eautoreconf in '${PWD}' ..."
136 flameeyes 1.38 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
137 azarah 1.17 eaclocal
138 grobian 1.83 [[ ${CHOST} == *-darwin* ]] && g=g
139     if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
140 vapier 1.72 _elibtoolize --copy --force --install
141     else
142     _elibtoolize --copy --force
143     fi
144 azarah 1.17 eautoconf
145     eautoheader
146 flameeyes 1.35 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
147 azarah 1.1
148 flameeyes 1.32 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
149    
150 flameeyes 1.30 # Call it here to prevent failures due to elibtoolize called _before_
151 vapier 1.84 # eautoreconf. We set $S because elibtoolize runs on that #265319
152 vapier 1.110 S=${PWD} elibtoolize --force
153 flameeyes 1.30
154 flameeyes 1.21 return 0
155 azarah 1.12 }
156    
157 vapier 1.107 # @FUNCTION: eaclocal_amflags
158 vapier 1.76 # @DESCRIPTION:
159 vapier 1.107 # Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
160     # (most) of the crazy crap that people throw at us.
161     eaclocal_amflags() {
162     local aclocal_opts amflags_file
163 azarah 1.12
164 vapier 1.74 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
165     [[ -e ${amflags_file} ]] || continue
166 vapier 1.103 # setup the env in case the pkg does something crazy
167     # in their ACLOCAL_AMFLAGS. like run a shell script
168 vapier 1.107 # which turns around and runs autotools. #365401
169     # or split across multiple lines. #383525
170 vapier 1.103 autotools_env_setup
171 vapier 1.107 aclocal_opts=$(sed -n \
172     "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
173     # match the first line
174     s:[^=]*=::p; \
175     # then gobble up all escaped lines
176     : nextline /\\\\$/{ n; p; b nextline; } \
177     }" ${amflags_file})
178     eval aclocal_opts=\""${aclocal_opts}"\"
179 vapier 1.74 break
180     done
181    
182 vapier 1.107 echo ${aclocal_opts}
183     }
184    
185     # @FUNCTION: eaclocal
186     # @DESCRIPTION:
187     # These functions runs the autotools using autotools_run_tool with the
188     # specified parametes. The name of the tool run is the same of the function
189     # without e prefix.
190     # They also force installing the support files for safety.
191     # Respects AT_M4DIR for additional directories to search for macro's.
192     eaclocal() {
193 flameeyes 1.22 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
194 vapier 1.107 autotools_run_tool aclocal $(autotools_m4dir_include) "$@" $(eaclocal_amflags)
195 azarah 1.12 }
196    
197 vapier 1.76 # @FUNCTION: _elibtoolize
198     # @DESCRIPTION:
199     # Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
200     # libtool.eclass.
201 azarah 1.12 _elibtoolize() {
202 grobian 1.83 local opts g=
203 swegener 1.20
204 flameeyes 1.34 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
205     # check for both it and the current AC_PROG_LIBTOOL)
206 vapier 1.77 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
207 azarah 1.19
208 flameeyes 1.70 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
209 swegener 1.20
210 grobian 1.83 [[ ${CHOST} == *-darwin* ]] && g=g
211     autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
212 flameeyes 1.15
213 azarah 1.12 # Need to rerun aclocal
214     eaclocal
215 azarah 1.11 }
216 azarah 1.1
217 vapier 1.76 # @FUNCTION: eautoheader
218     # @DESCRIPTION:
219     # Runs autoheader.
220 azarah 1.11 eautoheader() {
221 azarah 1.12 # Check if we should run autoheader
222     [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
223 flameeyes 1.102 NO_FAIL=1 autotools_run_tool autoheader $(autotools_m4dir_include) "$@"
224 azarah 1.11 }
225 azarah 1.1
226 vapier 1.76 # @FUNCTION: eautoconf
227     # @DESCRIPTION:
228     # Runs autoconf.
229 azarah 1.11 eautoconf() {
230 azarah 1.12 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
231     echo
232 vapier 1.91 eerror "No configure.{ac,in} present in '${PWD}'!"
233 azarah 1.12 echo
234     die "No configure.{ac,in} present!"
235     fi
236    
237 flameeyes 1.102 autotools_run_tool autoconf $(autotools_m4dir_include) "$@"
238 azarah 1.11 }
239 azarah 1.1
240 vapier 1.76 # @FUNCTION: eautomake
241     # @DESCRIPTION:
242     # Runs automake.
243 azarah 1.11 eautomake() {
244 flameeyes 1.24 local extra_opts
245 flameeyes 1.70 local makefile_name
246 flameeyes 1.24
247 vapier 1.98 # Run automake if:
248     # - a Makefile.am type file exists
249     # - a Makefile.in type file exists and the configure
250     # script is using the AM_INIT_AUTOMAKE directive
251     for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do
252     [[ -f ${makefile_name} ]] && break
253     done
254     [[ -z ${makefile_name} ]] && return 0
255    
256     if [[ ${makefile_name} == *.in ]] ; then
257     if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
258     return 0
259     fi
260 flameeyes 1.24
261 vapier 1.98 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
262 flameeyes 1.35 local used_automake
263     local installed_automake
264    
265 vapier 1.87 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
266 flameeyes 1.35 sed -e 's:.*(GNU automake) ::')
267 vapier 1.98 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
268 flameeyes 1.35 sed -e 's:.*by automake \(.*\) from .*:\1:')
269    
270     if [[ ${installed_automake} != ${used_automake} ]]; then
271     einfo "Automake used for the package (${used_automake}) differs from"
272     einfo "the installed version (${installed_automake})."
273     eautoreconf
274 flameeyes 1.36 return 0
275 flameeyes 1.35 fi
276     fi
277    
278 vapier 1.109 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
279 flameeyes 1.24 || extra_opts="${extra_opts} --foreign"
280    
281 flameeyes 1.14 # --force-missing seems not to be recognized by some flavours of automake
282 flameeyes 1.24 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
283 azarah 1.1 }
284    
285 vapier 1.90 # @FUNCTION: eautopoint
286     # @DESCRIPTION:
287     # Runs autopoint (from the gettext package).
288     eautopoint() {
289     autotools_run_tool autopoint "$@"
290     }
291    
292 azarah 1.17 # Internal function to run an autotools' tool
293 vapier 1.103 autotools_env_setup() {
294 flameeyes 1.86 # We do the “latest” → version switch here because it solves
295     # possible order problems, see bug #270010 as an example.
296 flameeyes 1.96 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
297 vapier 1.99 local pv
298 flameeyes 1.96 for pv in ${_LATEST_AUTOMAKE} ; do
299 robbat2 1.97 # has_version respects ROOT, but in this case, we don't want it to,
300     # thus "ROOT=/" prefix:
301     ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
302 flameeyes 1.96 done
303     [[ ${WANT_AUTOMAKE} == "latest" ]] && \
304     die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
305     fi
306 flameeyes 1.86 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
307 vapier 1.103 }
308     autotools_run_tool() {
309     if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
310     ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
311     fi
312    
313     autotools_env_setup
314 flameeyes 1.86
315 vapier 1.85 local STDERR_TARGET="${T}/$1.out"
316     # most of the time, there will only be one run, but if there are
317     # more, make sure we get unique log filenames
318     if [[ -e ${STDERR_TARGET} ]] ; then
319 vapier 1.104 local i=1
320     while :; do
321     STDERR_TARGET="${T}/$1-${i}.out"
322     [[ -e ${STDERR_TARGET} ]] || break
323     : $(( i++ ))
324     done
325 vapier 1.85 fi
326 azarah 1.17
327 vapier 1.85 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
328 azarah 1.17
329 azarah 1.27 ebegin "Running $@"
330 vapier 1.85 "$@" >> "${STDERR_TARGET}" 2>&1
331     eend $?
332 azarah 1.17
333 vapier 1.85 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
334 azarah 1.17 echo
335     eerror "Failed Running $1 !"
336     eerror
337     eerror "Include in your bugreport the contents of:"
338     eerror
339 vapier 1.85 eerror " ${STDERR_TARGET}"
340 azarah 1.17 echo
341     die "Failed Running $1 !"
342     fi
343     }
344    
345     # Internal function to check for support
346     autotools_check_macro() {
347 vapier 1.77 [[ -f configure.ac || -f configure.in ]] || return 0
348     local macro
349     for macro ; do
350 flameeyes 1.102 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
351 vapier 1.77 done
352 azarah 1.17 return 0
353     }
354    
355     # Internal function to get additional subdirs to configure
356     autotools_get_subdirs() {
357     local subdirs_scan_out
358    
359     subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
360     [[ -n ${subdirs_scan_out} ]] || return 0
361    
362     echo "${subdirs_scan_out}" | gawk \
363     '($0 !~ /^[[:space:]]*(#|dnl)/) {
364 azarah 1.25 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
365     print res[1]
366 azarah 1.17 }' | uniq
367 azarah 1.16
368 azarah 1.17 return 0
369 azarah 1.11 }
370 azarah 1.17
371 flameeyes 1.38 autotools_get_auxdir() {
372     local auxdir_scan_out
373    
374     auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
375     [[ -n ${auxdir_scan_out} ]] || return 0
376    
377     echo ${auxdir_scan_out} | gawk \
378     '($0 !~ /^[[:space:]]*(#|dnl)/) {
379     if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
380     print res[1]
381     }' | uniq
382    
383     return 0
384 vapier 1.40 }
385 flameeyes 1.102
386     autotools_m4dir_include() {
387     [[ -n ${AT_M4DIR} ]] || return
388    
389     local include_opts=
390    
391     for x in ${AT_M4DIR} ; do
392     case "${x}" in
393     "-I")
394     # We handle it below
395     ;;
396     *)
397     [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
398     include_opts="${include_opts} -I ${x}"
399     ;;
400     esac
401     done
402    
403     echo $include_opts
404     }
405 vapier 1.111
406     fi

  ViewVC Help
Powered by ViewVC 1.1.20